package io.zipcoder.interfaces;

import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

import static org.junit.Assert.*;

public class InstructorTest {

    private Instructor Nhu;
    private Student s1;
    private Student s2;

    @Before
    public void setup(){
        Nhu = new Instructor(3);
        s1 = new Student(1);
        s2 = new Student(2);
    }


    @Test
    public void instanceOfTeacher() {
        Assert.assertTrue(Nhu instanceof Teacher );
    }

    @Test
    public void instanceOfPerson() {
        Assert.assertTrue(Nhu instanceof Person);
    }

    @Test
    public void teach() {
        Nhu.teach(s1,3.0);

        double expected = 3.0;
        double actual = s1.getTotalStudyTime();

        Assert.assertEquals(expected,actual,0.1);
    }

    @Test
    public void lecture() {
        Student[] learners = new Student[]{s1,s2};
        Nhu.lecture(learners,12.0);

        double expected = 6.0;
        double actual = s1.getTotalStudyTime();

        Assert.assertEquals(expected,actual,0.1);
    }
}